Блог пользователя E869120

Автор E869120, 20 месяцев назад, По-английски

Hello, everyone!

Japanese Olympiad in Informatics (JOI) Spring Training 2025 (Contest URL) will be held from March 21st to 24th. There are 4 days in the contest.


The contest information is as follows. Details are available in contest page.

  • Number of problems for each contest: 3-4 problems
  • Style: IOI-Style (There may be some partial scores)
  • Problem Statement: Japanese & English
  • There may be some unusual task (e.g. output-only task, communication task) like IOI

The registration page and live scoreboard will be announced 10 minutes before the contest.

We welcome all participants. Good luck and have fun!


UPD1: Due to technical issue, the contest Day1 will be delayed by 30 minutes.
UPD2: Contest Day1 has finished. Now you can discuss the problem.
UPD3: Contest Day2 has finished. Now you can discuss the problem.
UPD4: Contest Day3 has finished. Now you can discuss the problem.
UPD5: Contest Day4 has finished. Thank you for your participation.

Теги joi, ioi
  • Проголосовать: нравится
  • +211
  • Проголосовать: не нравится

»
20 месяцев назад, скрыть # |
 
Проголосовать: нравится -208 Проголосовать: не нравится

Why C++ only?

»
20 месяцев назад, скрыть # |
 
Проголосовать: нравится +14 Проголосовать: не нравится

It's that time of the year again. Nice.

»
20 месяцев назад, скрыть # |
← Rev. 5  
Проголосовать: нравится 0 Проголосовать: не нравится

Now it's less than 10min before the contest starts, but I still cannot enter the contest site (502 Bad Gateway). Will this contest be delayed again?

Update: the contest site is accessible now, thanks for your fix!

»
20 месяцев назад, скрыть # |
 
Проголосовать: нравится +32 Проголосовать: не нравится

Solution for Exhibition?

  • »
    »
    20 месяцев назад, скрыть # ^ |
     
    Проголосовать: нравится +47 Проголосовать: не нравится

    Also waiting for the solution!

    • »
      »
      »
      20 месяцев назад, скрыть # ^ |
       
      Проголосовать: нравится +62 Проголосовать: не нравится
      My solution (upsolving)
»
20 месяцев назад, скрыть # |
 
Проголосовать: нравится 0 Проголосовать: не нравится

Whats the solution for Travel?

  • »
    »
    20 месяцев назад, скрыть # ^ |
     
    Проголосовать: нравится 0 Проголосовать: не нравится

    I used parallel binary search and dsu to calculate the maximum altitude you have to pass by to get from a to b,then for every position I found a position that I can reach and gives me the biggest altitude and then did binary lifting in that

    • »
      »
      »
      20 месяцев назад, скрыть # ^ |
      ← Rev. 2  
      Проголосовать: нравится 0 Проголосовать: не нравится

      I think there is a way without parallel binary search, if you sort the numbers in increasing order and maintain a DSU of reachable nodes. And you know that for each query a node will only transition to the biggest reachable node from it. Does anyone have a different solution?

»
20 месяцев назад, скрыть # |
 
Проголосовать: нравится +10 Проголосовать: не нравится

How to get more than 50 points in Ambulance?

»
20 месяцев назад, скрыть # |
← Rev. 4  
Проголосовать: нравится +30 Проголосовать: не нравится

Day $$$1$$$ Solutions Write ups:

Travel
Fortune Telling (50 points)
»
20 месяцев назад, скрыть # |
← Rev. 3  
Проголосовать: нравится +33 Проголосовать: не нравится

Day $$$2$$$ Solution Write ups:

Ambulance
Stamps
»
20 месяцев назад, скрыть # |
 
Проголосовать: нравится -17 Проголосовать: не нравится

Is there a solution with better complexity than O(n^2 * t) in Ambulance?

»
20 месяцев назад, скрыть # |
 
Проголосовать: нравится +94 Проголосовать: не нравится

After 10 years of trying I finally won JOISC 2025 Open!! So happy!!

»
20 месяцев назад, скрыть # |
 
Проголосовать: нравится 0 Проголосовать: не нравится

rank 12.How do you 900+ guy's mind work??u r too strong

»
19 месяцев назад, скрыть # |
← Rev. 2  
Проголосовать: нравится +23 Проголосовать: не нравится

Thank you for the nice problems. Overall I enjoyed the contest very much. Spending $$$8+$$$ hours (till $$$5$$$ am) on the same problem, and still unable to solve was somehow fun. Here are some more solutions for the problems I managed to solve

Day 3 Multi Communication
Day 4 Migration
Day 4 Uiro
Rant about Limits
  • »
    »
    19 месяцев назад, скрыть # ^ |
     
    Проголосовать: нравится 0 Проголосовать: не нравится

    also when is analysis mode?

  • »
    »
    19 месяцев назад, скрыть # ^ |
     
    Проголосовать: нравится +10 Проголосовать: не нравится

    Day 4 Migration can be solved in $$$O((n+q)\log n)$$$ time using segment tree merging.

    If you replace Sparse Table by the Method of Four Russians, the total complexity is $$$O((n+q)A)$$$, for we just want to solve many Interval Minimum queries.

    • »
      »
      »
      19 месяцев назад, скрыть # ^ |
       
      Проголосовать: нравится 0 Проголосовать: не нравится

      Does https://judge.yosupo.jp/submission/275418 implement method of 4 russians? I decided to copypaste the fastest submission on yosupo, did not help much

      • »
        »
        »
        »
        19 месяцев назад, скрыть # ^ |
         
        Проголосовать: нравится 0 Проголосовать: не нравится

        Sorry I mean at the problem Uiro, we can use 4 russians?

        • »
          »
          »
          »
          »
          19 месяцев назад, скрыть # ^ |
          ← Rev. 2  
          Проголосовать: нравится 0 Проголосовать: не нравится

          Yes i am saying I did use it actually (by copypasting the fastest submission from yosupo which implements it). The limits were still very tight for me. Can you provide your implementation?

          • »
            »
            »
            »
            »
            »
            19 месяцев назад, скрыть # ^ |
             
            Проголосовать: нравится 0 Проголосовать: не нравится

            Where can I find my code?

          • »
            »
            »
            »
            »
            »
            19 месяцев назад, скрыть # ^ |
             
            Проголосовать: нравится +17 Проголосовать: не нравится
            My code with Sparse Table
  • »
    »
    19 месяцев назад, скрыть # ^ |
    ← Rev. 3  
    Проголосовать: нравится +42 Проголосовать: не нравится

    Thank you for your participation! As a tutor (and proposer of some of the problems), I'm happy that you enjoyed the contest :)

    On "Rant about Limits" (for problem Migration):

    Why? Did you really need to block sqrt that much? Please set reasonable limits and not "well it runs in time, so its fine".

    Consider the optimized "naive simulation", which maintains the set of non-zero-populated vertices for each depth, and naively simulate the population movement by using level ancestor (simple binary lifting, $$$O(\log(X-Y))$$$ time per query). Surprisingly, I believe that this should achieve $$$O(n^{1.5})$$$ time! (The worst case should be that there are $$$\sqrt{N}$$$ legs of length $$$\sqrt{N}$$$ from the root.)

    Anyway in the onsite editorial, an $$$O(n \log n)$$$ solution which reduces to (offline) 2D range sum queries was mentioned, and the solution similar to yours was mentioned as an "alternative solution" :)
»
19 месяцев назад, скрыть # |
 
Проголосовать: нравится 0 Проголосовать: не нравится

Is editorial coming soon?

»
19 месяцев назад, скрыть # |
 
Проголосовать: нравится +23 Проголосовать: не нравится

Code for everything, except Exhibition3 / Fortune3 / Conference (camp25_*.cpp)

I think I can fill in Conference and Exhibition 3 soon. No idea for Fortune Telling 3 yet.

»
19 месяцев назад, скрыть # |
 
Проголосовать: нравится +32 Проголосовать: не нравится

How to solve brave?

  • »
    »
    19 месяцев назад, скрыть # ^ |
    ← Rev. 2  
    Проголосовать: нравится +32 Проголосовать: не нравится

    For problem "brave", two completely different approaches were mentioned in the onsite editorial, so I'll explain both of them.

    Premise: 24 points solution
    Solution 1: 67 points
    Solution 2: 100 points
    • »
      »
      »
      19 месяцев назад, скрыть # ^ |
       
      Проголосовать: нравится +8 Проголосовать: не нравится

      Thanks a lot!

    • »
      »
      »
      19 месяцев назад, скрыть # ^ |
       
      Проголосовать: нравится +16 Проголосовать: не нравится
      Nitpicking
»
19 месяцев назад, скрыть # |
 
Проголосовать: нравится 0 Проголосовать: не нравится

Anyone please help, where one can upsolve these cool problems?

»
19 месяцев назад, скрыть # |
 
Проголосовать: нравится +18 Проголосовать: не нравится

When will the problems be available for upsolve? Will they be available on oj.uz website ? So excited to upsolve the exciting and challenging problems.

»
19 месяцев назад, скрыть # |
 
Проголосовать: нравится +18 Проголосовать: не нравится

When will the testcases be published?

»
6 месяцев назад, скрыть # |
 
Проголосовать: нравится 0 Проголосовать: не нравится

Decided to post some leaking solution in english for all the upsolvers out there

Space Thief